<template>
  <div>
    <slot/>
  </div>
</template>

<script>
import {
  login as loginAction,
  register as registerAction,
  confirmAccount,
  forgotPassword as forgotPasswordAction,
  changePassword as changePasswordAction,
  updateUser as updateUserAction
} from "@/actions/UserAction";
import {provideMethods, provideDatas} from "@/libs/genProvider";
import {reactFromAPI, reactFromAPIPost} from "@/libs/reactFromAPI";
import {clearViolations} from "@/libs/formViolations";
import {reactFromAPIPut} from "../libs/reactFromAPI";
import {setSessionSetter} from "@/libs/request";

export default {
  name: "UserProvider",
  data: function () {
    return {
      session: null,
      violations: {
        email: [],
        password: [],
        confirm_password: [],
        firstname: [],
        lastname: [],
        gender: []
      },
      violationsPassword: {
        password: [],
        confirm_password: []
      },
      violationsUpdateUser: {
        firstname: [],
        lastname: [],
        gender: []
      }
    }
  },
  inject: ["createAlert"],
  beforeMount() {
    this.setSession();
    setSessionSetter(this.setSession);
  },
  provide() {
    const provider = {};

    provideMethods(provider, "user", this);
    provideDatas(provider, "user", this);

    return provider;
  },
  methods: {
    setSession() {
      this.session = JSON.parse(localStorage.getItem("currentUser"));
    },
    hasRole(roles) {
      if (!this.session === null)
        return null;
      if (!(roles instanceof Array))
        roles = [roles];

      return roles.some(role => this.session.roles.includes(role));
    },
    login: function (values) {
      loginAction(values).then(async (res) =>
          reactFromAPI(res, {}, this.createAlert, "Connexion réussie", 200).then(
              async (success) => {
                if (!success) return
                const {access_token, refresh_token, user} = await res.json();

                if (access_token) {
                  const currentUser = {...user, access_token, refresh_token};
                  localStorage.setItem('currentUser', JSON.stringify(currentUser));
                  this.session = currentUser;

                  setTimeout(() => {
                    this.$router.push("/")
                  }, 2000)
                }
              }
          )
      );
    },
    register: function (values) {
      registerAction(values).then(async res =>
          reactFromAPIPost(
              res,
              this.violations,
              this.createAlert,
              "Inscription réussie"
          ).then(success => {
            if (!success) return;
            setTimeout(() => {
              this.$router.push("/");
            }, 2000);
          })
      );
    },
    validate: function (token) {
      return confirmAccount(token);
    },
    logout() {
      this.session = null;
      localStorage.removeItem("currentUser");
      this.$router.push("/");
    },
    forgotPassword({email}) {
      return forgotPasswordAction(email)
          .then(res =>
              reactFromAPIPut(
                  res,
                  {},
                  this.createAlert,
                  "Un email a été envoyé"
              )
          )
    },
    changePassword(values,token = null) {
      changePasswordAction(values,token).then(async res =>
          reactFromAPIPut(
              res,
              this.violationsPassword,
              this.createAlert,
              "Mot de passe modifié avec succès !"
          ).then(success => {
            if (!success)
              return;

            values.password = "";
            values.confirm_password = "";

            if (token) {
              this.$router.push({name: 'accueil'})
            }
          })
      );
    },
    updateUser(values) {
      updateUserAction(values).then(async res =>
          reactFromAPIPut(
              res,
              this.violationsUpdateUser,
              this.createAlert,
              "Informations modifiées avec succès !"
          ).then(success => {
            if (!success)
              return;

            const newValues = {
              ...values,
              gender: {
                'H': true,
                'F': false,
                'A': null
              }[values.gender]
            }
            this.session = {
              ...this.session,
              ...newValues
            }
            localStorage.setItem("currentUser", JSON.stringify({
              ...JSON.parse(localStorage.getItem("currentUser")),
              ...newValues,
            }))
          })
      )
    },
    clearViolations() {
      clearViolations(this.violations);
    }
  }
};
</script>
